﻿<?php

class extra
{
    // Nifs a serem trocados por 999 999 990

    public $vatExcludes = array("000000000", "111111111", "999999999");
    public $version = 1.3;
    public $path_to_moloni = "view/template/moloni/";

    public function curPageURL($route = "")
    {
        if ($route == "") {
            $route = $_GET['route'];
        }
        $pageURL = 'http';
        if ($_SERVER["HTTPS"] == "on") {
            $pageURL .= "s";
        }

        $pageURL .= "://";
        if ($_SERVER["SERVER_PORT"] != "80") {
            $pageURL .=
                $_SERVER["SERVER_NAME"] . ":" . $_SERVER["SERVER_PORT"] . parse_url(
                    $_SERVER["REQUEST_URI"],
                    PHP_URL_PATH
                );
        } else {
            $pageURL .= $_SERVER["SERVER_NAME"] . parse_url($_SERVER["REQUEST_URI"], PHP_URL_PATH);
        }

        $pageURL .= "?route=" . $route . "&token=" . $_GET['token'];

        return $pageURL;
    }

    public function dateFormating($date = false, $format = "Y-m-d")
    {
        if (!$date) {
            $date = date();
        }
        $date = new DateTime($date);
        return ($date->format('Y-m-d'));
    }

    public function vatCheck($vat)
    {
        $vat = trim($vat);
        $vat = str_replace(" ", "", $vat);

        foreach ($this->vatExcludes as $excluded) {
            if ($vat == $excluded) {
                $vat = "";
            }
        }

        if ($vat == '') {
            $vat = "999999990";
        }

        return ($vat);
    }

    public function checkZip($zipCode, $country = "PT")
    {
        $zipCode = trim(str_replace(" ", "", $zipCode));
        $zipCode = preg_replace("/[^0-9]/", "", $zipCode);

        if (strlen($zipCode) == 7) {
            $zipCode = $zipCode[0] . $zipCode[1] . $zipCode[2] . $zipCode[3] . "-" . $zipCode[4] . $zipCode[5] . $zipCode[6];
        }

        if (strlen($zipCode) == 6) {
            $zipCode = $zipCode[0] . $zipCode[1] . $zipCode[2] . $zipCode[3] . "-" . $zipCode[4] . $zipCode[5] . "0";
        }

        if (strlen($zipCode) == 5) {
            $zipCode = $zipCode[0] . $zipCode[1] . $zipCode[2] . $zipCode[3] . "-" . $zipCode[4] . "00";
        }

        if (strlen($zipCode) == 4) {
            $zipCode = $zipCode . "-" . "000";
        }

        if (strlen($zipCode) == 3) {
            $zipCode = $zipCode . "0-" . "000";
        }

        if (strlen($zipCode) == 2) {
            $zipCode = $zipCode . "00-" . "000";
        }

        if (strlen($zipCode) == 1) {
            $zipCode = $zipCode . "000-" . "000";
        }

        if (strlen($zipCode) == 0) {
            $zipCode = "1000-100";
        }

        if ($this->verify($zipCode)) {
            return ($zipCode);
        }

        return ("1000-100");
    }

    public function verify($zipCode)
    {
        $regexp = "/[0-9]{4}\-[0-9]{3}/";
        if (preg_match($regexp, $zipCode)) {
            return (true);
        }

        return (false);
    }
}

class errorReport
{
    private $errRes = array();

    public function create($title, $url, $values, $result)
    {
        $this->errRes = array(
            "exist" => 1,
            "title" => $title,
            "url" => $url,
            "values" => $values,
            "result" => $result
        );
        $this->get();
        return (true);
    }

    public function get()
    {
        if ($this->errRes['exist'] == true) {
            if (isset($this->errRes['result']['error_description'])) {
                $message = $this->errRes['result']['error_description'];
            } else {
                $message = $this->errRes['result'][0];
            }
            echo "<div class='container-fluid'>";
            echo "<h3>Ups, foi encontrado um erro... :(</h3><br>";
            echo "<h4><b>" . $this->errRes['title'] . "</b><br><br>";
            echo $this->translate($message);
            echo "</h4><br>";
            echo "<div class='error-message'><pre>";
            print_r($this->errRes['url']);
            echo "<br>";
            print_r($this->errRes['values']);
            echo "<br>";
            print_r($this->errRes['result']);
            echo "</pre></div>";
            echo "</div>";
            exit;
        }
    }

    public function sqlConnect($errString)
    {
        $this->errRes = array(
            "exist" => 1,
            "title" => "Erro ao ligar à Base de dados",
            "descr" => $errString
        );
        $this->sqlConnectGET();
        return (true);
    }

    public function sqlConnectGET()
    {
        if ($this->errRes['exist'] == true) {
            echo "<div class='container-fluid'>";
            echo "<h3>Ups, foi encontrado um erro... :(</h3><br>";
            echo "<h4>" . $this->errRes['title'] . "</h4><br>";
            echo "<div class='error-message'>" . $this->errRes['descr'] . "</div>";
            echo "</div>";
            exit;
        }
    }

    public function translate($errMessage)
    {
        $error = preg_replace('#[0-9 ]*#', '', $errMessage);
        switch ($error) {
            case 'Missing parameters: "username" and "password" required':
                $message = "Ambos os parametros são obrigatórios.";
                break;
            case 'Invalid username and password combination':
                $message = "Combinação errada.";
                break;
            case 'contact_email':
            case 'email':
                $message = "Email de cliente errado.";
                break;
            case 'website':
                $message = "Website de cliente inválido.";
                break;

            case 'vat':
                $message = "Erro no nº de contribuinte.";
                break;

            case 'reference':
                $message = "Referência de artigo repetida.";
                break;

            case 'delivery_destination_zip_code':
                $message = "Código postal de entrega errado";
                break;
        }

        if (isset($message)) {
            return ($message);
        }

        return (false);
    }

}
