<?php

class oc
{
    public $sql;
    public $categoriesExclude = array("0", "7", "8", "9", "10", "11", "12", "13", "1", "16", "14");

    public function __construct()
    {
        $this->sql = new sql();
    }

    public function getOrdersAll()
    {
        $sWhere = " WHERE ";
        foreach ($this->categoriesExclude as $categoryID) {
            $sWhere .= " order_status_id <> $categoryID AND ";
        }
        $sWhere .= " moloni_invoice < 10";
        $result = $this->sql->getAll(
            "SELECT * FROM `" . DB_PREFIX . "order` $sWhere AND order_status_id > 0 ORDER BY date_added DESC"
        );

        if (is_array($result) && count($result) > 0) {
            return ($result);
        }

        return (false);
    }

    public function orderDeleteOne($id)
    {
        $this->sql->command("UPDATE `" . DB_PREFIX . "order` SET moloni_invoice = '11' WHERE order_id = " . $id . "");
        return (true);
    }

    public function getOrdersInvoices()
    {
        $result = $this->sql->getAll(
            "SELECT * FROM `" . DB_PREFIX . "order` WHERE moloni_invoice > 20 ORDER BY moloni_invoice DESC LIMIT 30"
        );
        return ($result);
    }


    public function getStatusOne($id = 1)
    {
        $result = $this->sql->getAll("SELECT * FROM `" . DB_PREFIX . "order_status` WHERE order_status_id = $id");
        return ($result[0]);
    }

    public function getCustomFields()
    {
        $result = $this->sql->getAll("SELECT * FROM `" . DB_PREFIX . "custom_field_description`");
        return ($result);
    }

    public function getVatFromOrder($order)
    {
        $extras = new extra();
        if ($this->isSerial($order['payment_custom_field']) || $this->isSerial($order['custom_field'])) {
            $results = unserialize($order['custom_field']);
            if (isset($results[VAT_FIELD])) {
                $vat = $results[VAT_FIELD];
            } else {
                unset($results);
                $results = unserialize($order['payment_custom_field']);
                if (isset($results[VAT_FIELD])) {
                    $vat = $results[VAT_FIELD];
                }
            }
        } else {
            $decoding = json_decode($order['payment_custom_field'], true);
            if (isset($decoding[VAT_FIELD])) {
                $vat = $extras->vatCheck($decoding[VAT_FIELD]);
            } else {
                unset($decoding);
                $decoding = json_decode($order['custom_field'], true);
                if (isset($decoding[VAT_FIELD])) {
                    $vat = $extras->vatCheck($decoding[VAT_FIELD]);
                }
            }
        }

        if (trim($vat) === '') {
            return "999999990";
        }

        return $vat;
    }

    public function isJson($input)
    {
        $output = json_encode($input);
        return json_last_error() === JSON_ERROR_NONE;
    }

    public function isSerial($input)
    {
        return (@unserialize($input) !== false || $input === 'a:0;') ? true : false;
    }

    public function orderGetOne($id)
    {
        $orderR = $this->sql->getAll("SELECT * FROM `" . DB_PREFIX . "order` WHERE order_id = $id");

        if (count($orderR[0]) > 0) {
            $productsR = $this->sql->getAll("SELECT * FROM `" . DB_PREFIX . "order_product` WHERE order_id = $id");
            $totalR = $this->sql->getAll("SELECT * FROM `" . DB_PREFIX . "order_total` WHERE order_id = $id");

            foreach ($productsR as $key => $product) {
                $optionsR = $this->sql->getAll(
                    "SELECT * FROM `" . DB_PREFIX . "order_option` WHERE order_id = $id AND order_product_id = $product[order_product_id]"
                );
                $productsR[$key]['description'] = "";
                $break = "";
                if ($optionsR) {
                    foreach ($optionsR as $br => $option) {
                        if ($br > 0) {
                            $break = "<br>";
                        }
                        $productsR[$key]['description'] .= $break . " - " . $option['name'] . ": " . $option['value'];
                    }
                    $productsR[$key]['options'] = $optionsR;
                }
                $stockR = $this->sql->getAll(
                    "SELECT * FROM `" . DB_PREFIX . "product` WHERE product_id = $product[product_id]"
                );
                $productsR[$key]['stock'] = $stockR[0];

                $description = $this->sql->getAll(
                    "SELECT * FROM `" . DB_PREFIX . "product_description` WHERE product_id = $product[product_id] AND language_id = '" . LANG_ID . "'"
                );
                $productsR[$key]['stock']['description'] = $description[0];
            }

            foreach ($totalR as $row) {
                $totalArray[$row['code']]['value'] = $row['value'];
                $totalArray[$row['code']]['title'] = $row['title'];
            }

            $order['info'] = $orderR[0];
            $order['products'] = $productsR;
            $order['totals'] = $totalArray;
            $order['vat'] = $this->getVatFromOrder($orderR[0]);

            return ($order);
        }

        return false;
    }

    public function getVoucherDiscount($totals)
    {
        if (isset($totals['voucher']) > 0) {
            $voucher = abs($totals['voucher']['value']);
            $coupon = 0;
            $tax = 0;

            if (isset($totals['tax']) > 0) {
                $tax = abs($totals['tax']['value']);
            }
            if (isset($totals['coupon']) > 0) {
                $coupon = abs($totals['coupon']['value']);
            }

            $total = $totals['sub_total']['value'];
            $result = round(($voucher * 100) / $total, 3);

            if ($result > "100") {
                $result = "100";
            }

            return ($result);
        }

        return ("0");
    }

    public function getCouponDiscount($totals)
    {
        if (isset($totals['coupon']) > 0) {
            $total = $totals['sub_total']['value'];
            $coupon = abs($totals['coupon']['value']);

            $result = round(($coupon * 100) / $total, 3);

            if ($result > "100") {
                $result = "100";
            }

            return ($result);
        }

        return ("0");
    }

    public function getContryCode($id)
    {
        $country = $this->sql->getAll("SELECT * FROM `" . DB_PREFIX . "country` WHERE country_id = $id");
        if (count($country) == 0) {
            $iso2 = "PT";
        } else {
            $iso2 = $country[0]['iso_code_2'];
        }

        $general = new general();
        $countries = $general->getCountriesAll();
        $languages = $general->getLanguagesAll();
        $info = array();

        foreach ($countries as $moloniCountry) {
            if (strtolower($iso2) == $moloniCountry['iso_3166_1']) {
                $info['country_id'] = $moloniCountry['country_id'];
            }
        }

        foreach ($languages as $moloniLanguage) {
            if ($iso2 == $moloniLanguage['code']) {
                $info['language_id'] = $moloniLanguage['language_id'];
            }
        }

        if (empty($info['language_id']) || !isset($info['language_id'])) {
            $info['language_id'] = "1";
        }

        return ($info);
    }

    public function clientCheck($order)
    {
        $entities = new entities();
        $extras = new extra();
        $clientInfo = array();
        $exists = false;

        $values['vat'] = $order['vat'];
        $clients = $entities->getCustomerByVat($values);

        foreach ($clients as $client) {
            if ($client['vat'] == $values['vat']) {
                $exists = true;
                $customerVat = $client['vat'];
                $customerID = $client['customer_id'];
            }
        }

        if ($exists == true and $customerVat == "999999990" and UPDATE_FINAL_CONSUMER == true) {
            unset($values);

            if ($order['info']['payment_company'] <> '') {
                $name = $order['info']['payment_company'];
            } else {
                $name = $order['info']['payment_firstname'] . " " . $order['info']['payment_lastname'];
            }

            if ($order['info']['payment_address_2'] <> '') {
                $address = $order['info']['payment_address_1'] . "<br>" . $order['info']['payment_address_2'];
            } else {
                $address = $order['info']['payment_address_1'];
            }

            $zip = $extras->checkZip($order['info']['payment_postcode']);

            $general = new general();
            $company = $general->getCompanyOne();
            $codes = $this->getContryCode($order['info']['payment_country_id']);

            $number = $order['info']['customer_id'] . rand(100000, 999999);
            if (trim($number) == "" or $number == 0) {
                $number = rand(100000, 999999);
            }
            $number = CLIENT_PREFIX . str_pad($number, 3, '0', STR_PAD_LEFT);

            $values['vat'] = $customerVat;
            $values['number'] = $number;
            $values['name'] = $name;
            $values['language_id'] = $codes['language_id'];
            $values['address'] = $address;
            $values['zip_code'] = $zip;
            $values['city'] = $order['info']['payment_city'];
            $values['country_id'] = $codes['country_id'];
            $values['email'] = $order['info']['email'];
            $values['website'] = "";
            $values['phone'] = $order['info']['telephone'];
            $values['fax'] = $order['info']['fax'];
            $values['contact_name'] = $order['info']['payment_firstname'] . " " . $order['info']['payment_lastname'];
            $values['contact_email'] = $order['info']['email'];
            $values['contact_phone'] = $order['info']['telephone'];
            $values['maturity_date_id'] = MATURITY_DATE;
            $values['qty_copies_document'] = $company['docs_copies'];
            $values['payment_method_id'] = PAYMENT_METHOD;
            $values['notes'] = "";
            $values['salesman_id'] = "";
            $values['payment_day'] = "";
            $values['discount'] = "0";
            $values['credit_limit'] = "0";
            $values['delivery_method_id'] = "0";

            $result = $entities->insertCustomer($values);
            if (!isset($result['customer_id'])) {
                $error = new errorReport();
                $error->create("Erro ao inserir utilizador", "customer/insert", $values, $result);
                $error->get();
                return (false);
            }

            $customerID = $result['customer_id'];
        }


        if (!$exists) {
            unset($values);

            if ($order['info']['payment_company'] <> '') {
                $name = $order['info']['payment_company'];
            } else {
                $name = $order['info']['payment_firstname'] . " " . $order['info']['payment_lastname'];
            }

            if ($order['info']['payment_address_2'] <> '') {
                $address = $order['info']['payment_address_1'] . "<br>" . $order['info']['payment_address_2'];
            } else {
                $address = $order['info']['payment_address_1'];
            }

            $zip = $extras->checkZip($order['info']['payment_postcode']);

            $general = new general();
            $company = $general->getCompanyOne();
            $codes = $this->getContryCode($order['info']['payment_country_id']);

            $number = $order['info']['customer_id'];
            if (trim($number) == "" or $number == 0) {
                $number = mt_rand(100000, 999999);
            }
            $number = CLIENT_PREFIX . str_pad($number, 3, '0', STR_PAD_LEFT);

            $values['vat'] = $order['vat'];
            $values['number'] = $number;
            $values['name'] = $name;
            $values['language_id'] = $codes['language_id'];
            $values['address'] = $address;
            $values['zip_code'] = $zip;
            $values['city'] = $order['info']['payment_city'];
            $values['country_id'] = $codes['country_id'];
            $values['email'] = $order['info']['email'];
            $values['website'] = "";
            $values['phone'] = $order['info']['telephone'];
            $values['fax'] = $order['info']['fax'];
            $values['contact_name'] = $order['info']['payment_firstname'] . " " . $order['info']['payment_lastname'];
            $values['contact_email'] = $order['info']['email'];
            $values['contact_phone'] = $order['info']['telephone'];
            $values['maturity_date_id'] = MATURITY_DATE;
            $values['qty_copies_document'] = $company['docs_copies'];
            $values['payment_method_id'] = PAYMENT_METHOD;
            $values['notes'] = "";
            $values['salesman_id'] = "";
            $values['payment_day'] = "";
            $values['discount'] = "0";
            $values['credit_limit'] = "0";
            $values['delivery_method_id'] = "0";

            $result = $entities->insertCustomer($values);
            if (!isset($result['customer_id'])) {
                $error = new errorReport();
                $error->create("Erro ao inserir utilizador", "customer/insert", $values, $result);
                $error->get();
                return (false);
            } else {
                $customerID = $result['customer_id'];
            }
        }


        return ($customerID);
    }


    public function getTaxID($tax)
    {
        $general = new general();
        $taxRate = round($tax);
        $taxRates = $general->getTaxesAll();

        foreach ($taxRates as $rate) {
            if ($rate['value'] == $taxRate) {
                return ($rate['tax_id']);
            }
        }

        return ($taxRates[0]['tax_id']);
    }

    public function productCheck($product)
    {
        $products = new products();
        $exists = false;

        if (trim($product['model']) <> '') {
            $reference = PRODUCT_PREFIX . $product['model'];
        } else {
            $reference = PRODUCT_PREFIX . mb_str_pad($product['product_id'], 3, '0', STR_PAD_LEFT);
        }

        $reference = mb_substr($reference, 0, 20);
        if (@count($product['options']) > 0) {
            foreach ($product['options'] as $option) {
                $reference .= "_" . $option['product_option_value_id'];
            }
        }

        $existsCheck = $products->getProductsByRef($reference);
        if (count($existsCheck) > 0) {
            $exists = true;
            $productID = $existsCheck[0]['product_id'];
        }

        if (!$exists) {
            $values['category_id'] = $this->categoryCheck($product['product_id']);
            $values['type'] = "1";
            $values['name'] = $product['name'];
            $values['summary'] = "";
            $values['reference'] = $reference;
            $values['ean'] = $product['ean'];
            $values['price'] = $product['price'];
            $values['unit_id'] = MEASURE_UNIT;
            $values['has_stock'] = "1";
            $values['stock'] = $product['stock']['quantity'];
            $values['pos_favorite'] = "0";
            $values['at_product_category'] = "M";
            $values['exemption_reason'] = EXEMPTION_REASON;
            $values['taxes'][0]['tax_id'] = $this->getTaxID(($product['tax'] * 100) / $product['price']);
            $values['taxes'][0]['value'] = $product['tax'];
            $values['taxes'][0]['order'] = "1";
            $values['taxes'][0]['cumulative'] = "0";

            $result = $products->insertProduct($values);

            if (!isset($result['product_id'])) {
                $error = new errorReport();
                $error->create("Erro ao inserir artigo", "product/insert", $values, $result);
                $error->get();
                return (false);
            }

            $productID = $result['product_id'];
        }

        return ($productID);
    }

    public function shippingCheck($shipping)
    {
        $products = new products();
        $reference = "";
        $exists = false;

        if (trim($shipping['title']) <> '') {
            $words0 = explode(" ", $shipping['title']);
            foreach ($words0 as $word) {
                $reference = $reference . "." . substr($word, 0, 3);
            }
            $reference = trim($reference, ".");
            $reference = PRODUCT_PREFIX . strtoupper($reference);
        } else {
            $reference = "PORTES";
        }

        $reference = "PORTES";
        $existsCheck = $products->getProductsByRef($reference);

        if (count($existsCheck) > 0) {
            foreach ($existsCheck as $prod) {
                if (strtolower($prod['reference']) == strtolower($reference)) {
                    $exists = true;
                    $productID = $prod['product_id'];
                }
            }
        }

        if (!$exists) {
            $values['category_id'] = $this->categoryCheck("portes");
            $values['type'] = "1";
            $values['name'] = $shipping['title'];
            $values['summary'] = "";
            $values['reference'] = $reference;
            $values['ean'] = "";
            $values['price'] = $shipping['value'] / 1.23;
            $values['unit_id'] = MEASURE_UNIT;
            $values['has_stock'] = "0";
            $values['stock'] = "";
            $values['pos_favorite'] = "0";
            $values['at_product_category'] = "";
            $values['exemption_reason'] = EXEMPTION_REASON;
            $values['taxes'][0]['tax_id'] = $this->getTaxID(23);
            $values['taxes'][0]['value'] = round(($shipping['value'] * 23) / 100, 4);
            $values['taxes'][0]['order'] = "1";
            $values['taxes'][0]['cumulative'] = "0";

            $result = $products->insertProduct($values);

            if (!isset($result['product_id'])) {
                $error = new errorReport();
                $error->create("Erro ao inserir portes", "product/insert", $values, $result);
                $error->get();
                return (false);
            }

            $productID = $result['product_id'];
        }

        return ($productID);
    }

    public function xfee($xfee)
    {
        $exists = false;
        $products = new products();

        $reference = $xfee['reference'];
        $existsCheck = $products->getProductsByRef($reference);

        if (count($existsCheck) > 0) {
            foreach ($existsCheck as $prod) {
                if (strtolower($prod['reference']) == strtolower($reference)) {
                    $exists = true;
                    $xfeeID = $prod['product_id'];
                }
            }
        }

        if (!$exists) {
            $values['category_id'] = $this->categoryCheck("Portes");
            $values['type'] = "1";
            $values['name'] = $xfee['name'];
            $values['summary'] = "";
            $values['reference'] = $reference;
            $values['ean'] = "";
            $values['price'] = $xfee['price'] / 1.23;
            $values['unit_id'] = MEASURE_UNIT;
            $values['has_stock'] = "0";
            $values['stock'] = "";
            $values['pos_favorite'] = "0";
            $values['at_product_category'] = "";
            #$values['exemption_reason'] = EXEMPTION_REASON;
            $values['taxes'][0]['tax_id'] = $this->getTaxID(23);
            $values['taxes'][0]['value'] = round(($xfee['price'] * 23) / 100, 4);
            $values['taxes'][0]['order'] = "1";
            $values['taxes'][0]['cumulative'] = "0";

            $result = $products->insertProduct($values);

            if (!isset($result['product_id'])) {
                $error = new errorReport();
                $error->create("Erro ao inserir taxa de serviÃ§o", "product/insert", $values, $result);
                $error->get();
                return (false);
            }

            $xfeeID = $result['product_id'];
        }

        return ($xfeeID);
    }

    public function categoryCheck($product)
    {
        if ($product === 'portes') {
            $prod_to_category = false;
        } else {
            $prod_to_category = $this->sql->getAll(
                "SELECT * FROM `" . DB_PREFIX . "product_to_category` WHERE product_id = $product "
            );
        }

        if ($prod_to_category) {
            $category = $this->sql->getAll(
                "SELECT * FROM `" . DB_PREFIX . "category_description` WHERE category_id = " . $prod_to_category[0]['category_id'] . " AND language_id = " . LANG_ID . ""
            );
            $categoryName = $category[0]['name'];
            $categoryDescription = $category[0]['name'];
        } else {
            $categoryName = "Opencart";
            $categoryDescription = "";
        }

        if ($categoryName == "") {
            $categoryName = "Opencart";
        }


        $categoryFound = false;
        $products = new products();

        $categoriesMoloni = $products->getCategoriesAll(0);
        foreach ($categoriesMoloni as $categoryMoloni) {
            if (mb_strtolower($categoryMoloni['name']) === mb_strtolower($categoryName)) {
                $categoryFound = $categoryMoloni['category_id'];
                break;
            }
            if ($categoryMoloni['num_categories'] > 0) {
                $categoriesMoloni_1 = $products->getCategoriesAll($categoryMoloni['category_id']);
                foreach ($categoriesMoloni_1 as $categoryMoloni_1) {
                    if (strtolower($categoryMoloni_1['name']) === strtolower($categoryName)) {
                        $categoryFound = $categoryMoloni_1['category_id'];
                        break;
                    }
                    if ($categoryMoloni_1['num_categories'] > 0) {
                        $categoriesMoloni_2 = $products->getCategoriesAll($categoryMoloni_1['category_id']);
                        foreach ($categoriesMoloni_2 as $categoryMoloni_2) {
                            if (mb_strtolower($categoryMoloni_2['name']) === mb_strtolower($categoryName)) {
                                $categoryFound = $categoryMoloni_2['category_id'];
                                break;
                            }
                        }
                    }
                }
            }
        }

        if (!$categoryFound) {
            $values['parent_id'] = 0;
            $values['name'] = $categoryName;
            $values['description'] = $categoryDescription;
            $values['pos_enabled'] = "1";

            $insert = $products->insertCategory($values);
            $categoryFound = $insert['category_id'];
        }

        return ($categoryFound);
    }


    public function emailPopulate($email, $order, $pdf)
    {
        $emailText = $email;

        if ($order['info']['payment_company'] <> '') {
            $name = $order['info']['payment_company'];
        } else {
            $name = $order['info']['payment_firstname'] . " " . $order['info']['payment_lastname'];
        }

        $firstName = $order['info']['payment_firstname'];
        $lastName = $order['info']['payment_lastname'];
        $company = $order['info']['payment_company'];

        $orderNum = $order['info']['order_id'];


        $emailText = str_replace(
            ["\n", "\r", "{NAME}", "{ORDERNUM}", "{FIRSTNAME}", "{LASTNAME}", "{COMPANY}", "{INVOICE}"],
            ["<br>", "<br>", $name, $orderNum, $firstName, $lastName, $lastName, $pdf['url']],
            $emailText
        );

        return ($emailText);
    }
}
