<?php

$oc = new oc();
$ocOrder = $oc->orderGetOne($_GET['docId']);
if ($ocOrder) {
    $invoice['company_id'] = COMPANY;
    $invoice['date'] = date("Y-m-d");
    $invoice['expiration_date'] = date("Y-m-d");
    $invoice['document_set_id'] = DOCUMENT_SET_ID;
    $invoice['customer_id'] = $oc->clientCheck($ocOrder);
    $invoice['our_reference'] = "#" . $_GET['docId'];
    $invoice['your_reference'] = "";
    $invoice['financial_discount'] = $oc->getVoucherDiscount($ocOrder['totals']);
    $invoice['salesman_id'] = "";
    $invoice['salesman_commission'] = "";
    $invoice['deduction_id'] = "";
    $invoice['special_discount'] = "";
    $invoice['products'] = array();
    $counter = "0";
    foreach ($ocOrder['products'] as $key => $product) {
        if ($product['price'] >= 0) {
            $invoice['products'][$counter]['product_id'] = $oc->productCheck($product);
            $invoice['products'][$counter]['name'] = $product['name'];
            $invoice['products'][$counter]['summary'] = $product['description'];
            $invoice['products'][$counter]['qty'] = $product['quantity'];
            $invoice['products'][$counter]['price'] = $product['price'];
            $invoice['products'][$counter]['discount'] = $oc->getCouponDiscount($ocOrder['totals']);
            $invoice['products'][$counter]['order'] = $counter;

            if ($product['tax'] > 0) {
                $invoice['products'][$counter]['taxes'][0]['tax_id'] = $oc->getTaxID(($product['tax'] * 100) / $product['price']);
                $invoice['products'][$counter]['taxes'][0]['value'] = $product['tax'];
                $invoice['products'][$counter]['taxes'][0]['order'] = "1";
                $invoice['products'][$counter]['taxes'][0]['cumulative'] = "0";
            } else {
                $invoice['products'][$counter]['exemption_reason'] = EXEMPTION_REASON;
            }

            $counter++;
        }
    }

    if (isset($ocOrder['totals']['shipping']['value']) && $ocOrder['totals']['shipping']['value'] > 0) {
        $invoice['products'][$counter]['product_id'] = $oc->shippingCheck($ocOrder['totals']['shipping']);
        $invoice['products'][$counter]['name'] = $ocOrder['totals']['shipping']['title'];
        $invoice['products'][$counter]['summary'] = "";
        $invoice['products'][$counter]['qty'] = "1";
        $invoice['products'][$counter]['price'] = $ocOrder['totals']['shipping']['value'];
        $invoice['products'][$counter]['discount'] = "";
        $invoice['products'][$counter]['order'] = $counter;
        if ($ocOrder['totals']['tax']['value'] > 0) {
            $invoice['products'][$counter]['taxes'][0]['tax_id'] = $oc->getTaxID("23");
            $invoice['products'][$counter]['taxes'][0]['value'] = $ocOrder['totals']['tax']['value'];
            $invoice['products'][$counter]['taxes'][0]['order'] = "1";
            $invoice['products'][$counter]['taxes'][0]['cumulative'] = "0";
        } else {
            $invoice['products'][$counter]['exemption_reason'] = EXEMPTION_REASON_SHIPPING;
        }

        $counter++;
    }

    foreach ($ocOrder['totals'] as $key => $value) {
        switch ($key) {
            case "xfee1" :
                $xfeeIndex = "xfee1";
                break;
            case "xfee2" :
                $xfeeIndex = "xfee2";
                break;
            case "xfee3" :
                $xfeeIndex = "xfee3";
                break;
            case "payment_fee" :
                $xfeeIndex = "payment_fee";
                break;
        }
    }

    if (@isset($ocOrder['totals'][$xfeeIndex]['value'])) {

        $xfee['name'] = $ocOrder['totals'][$xfeeIndex]['title'];
        $xfee['price'] = $ocOrder['totals'][$xfeeIndex]['value'];
        $xfee['reference'] = "xfee";

        $invoice['products'][$counter]['product_id'] = $oc->xfee($xfee);
        $invoice['products'][$counter]['name'] = $xfee['name'];
        $invoice['products'][$counter]['summary'] = "";
        $invoice['products'][$counter]['qty'] = "1";
        $invoice['products'][$counter]['price'] = $xfee['price'] / 1.23;
        $invoice['products'][$counter]['discount'] = "";
        $invoice['products'][$counter]['order'] = $counter;

        if ($product['tax'] > 0) {
            $invoice['products'][$counter]['taxes'][0]['tax_id'] = $oc->getTaxID("23");
            $invoice['products'][$counter]['taxes'][0]['value'] = "23";
            $invoice['products'][$counter]['taxes'][0]['order'] = "1";
            $invoice['products'][$counter]['taxes'][0]['cumulative'] = "0";
        } else {
            $invoice['products'][$counter]['exemption_reason'] = EXEMPTION_REASON;
        }

        $counter++;
    }

    if (SHIPPING_INFO) {
        $invoice['delivery_departure_address'] = $company['address'];
        $invoice['delivery_departure_city'] = $company['city'];
        $invoice['delivery_departure_zip_code'] = $company['zip_code'];
        $invoice['delivery_departure_country'] = $company['country']['country_id'];

        $codes = $oc->getContryCode($ocOrder['info']['shipping_country_id']);
        $zip = $extra->checkZip($ocOrder['info']['shipping_postcode']);
        if ($ocOrder['info']['shipping_address_2'] <> '') {
            $address = $ocOrder['info']['shipping_address_1'] . "<br>" . $ocOrder['info']['shipping_address_2'];
        } else {
            $address = $ocOrder['info']['shipping_address_1'];
        }
        $invoice['delivery_destination_address'] = $address;
        $invoice['delivery_destination_city'] = $ocOrder['info']['shipping_city'];
        $invoice['delivery_destination_zip_code'] = $zip;
        $invoice['delivery_destination_country'] = $codes['country_id'];

        $invoice['delivery_datetime'] = date('Y-m-d h:i:s');
    }

    $invoice['status'] = "0";

    $result = $documents->insertInvoice($invoice, DOCUMENT_TYPE);

    if (!isset($result['document_id'])) {
        $error = new errorReport();
        $error->create("Erro ao inserir documento", DOCUMENT_TYPE, $invoice, $result);
        $error->get();
    } else {
        $message = "";
        $pdfLink = false;

        $sql->command("UPDATE `" . DB_PREFIX . "order` SET moloni_invoice = '" . $result['document_id'] . "' WHERE order_id = " . $_GET['docId'] . "");

        if (DOCUMENT_STATUS) {

            $values['document_id'] = $result['document_id'];
            $documentGetOne = $documents->getOneInfo($values, DOCUMENT_TYPE);

            if (round($ocOrder['info']['total'], 2) == round($documentGetOne['net_value'], 2)) {
                $updateValues['document_id'] = $result['document_id'];
                $updateValues['status'] = "1";
                $documents->updateOne($updateValues, DOCUMENT_TYPE);

                $pdfLink = $general->getPDFLink($values);

                $message = '<div class="alert alert-success"><i class="fa fa-check-circle"></i> Documento inserido no Moloni - <a href="' . $pdfLink["url"] . '" target="_BLANK">Ver</a> <button type="button" class="close" data-dismiss="alert">×</button></div>';

            } else {
                $message = '<div class="alert alert-success"><i class="fa fa-check-circle"></i> Documento inserido no Moloni | AVISO: OS TOTAIS NÃO CORRESPONDEM <button type="button" class="close" data-dismiss="alert">×</button></div>';

            }
        } else {
            $message = '<div class="alert alert-success"><i class="fa fa-check-circle"></i> Documento inserido no Moloni  <button type="button" class="close" data-dismiss="alert">×</button></div>';
        }

        echo $message;

        if (EMAIL_SEND && EMAIL_SENDER && EMAIL_TEXT && isset($pdfLink['url']) and DOCUMENT_STATUS) {
            $message = '<div class="alert alert-success"><i class="fa fa-check-circle"></i>Documento enviado por email para o cliente: ' . $ocOrder['info']['email'] . '</div>';
            $emailInfo['senderName'] = $company['mails_sender_name'];
            $emailInfo['senderEmail'] = EMAIL_SENDER;
            $emailInfo['toEmail'] = $ocOrder['info']['email'];
            $emailInfo['subject'] = "Envio de Factura #" . $_GET['docId'];
            $emailInfo['text'] = $oc->emailPopulate(EMAIL_TEXT, $ocOrder, $pdfLink);

            echo '<div class="alert alert-success"><i class="fa fa-check-circle"></i>Documento enviado por email para o cliente: ' . $ocOrder['info']['email'] . '</div>';
            echo "<pre>";
            print_r($emailInfo);
            echo "</pre>";


            $mail = new Mail();

            $mail->setTo($emailInfo['toEmail']);
            $mail->setFrom($emailInfo['senderEmail']);
            $mail->setSender($emailInfo['senderEmail']);
            $mail->setReplyTo($emailInfo['senderEmail']);
            $mail->setSubject($emailInfo['subject']);
            $mail->setHtml($emailInfo['text']);

            $mail->send();

        }

        require("invoice.index.php");
    }

}
